<template>
  <div class="VideoMode" :ref="'container'+ _uid"  style="width:100%;height:100%;background-color: #000000;margin:0 auto;">
    <div class="buttons-box" id="buttonsBox">
      <div class="buttons-box-left">
        <img v-if="!playing" src="@/assets/monitorpublic/spjk_ks1.png" class="iconfont jessibuca-btn" @click="playBtnClick">
        <img v-if="playing" src="@/assets/monitorpublic/spjk_zt1.png" class="iconfont jessibuca-btn" @click="pause">
      </div>
      <div class="buttons-box-right">
        <!-- <img v-if="isNotMute" src="@/assets/monitorpublic/spjk_sy.png" class="iconfont jessibuca-btn" @click="mute()">
        <img v-if="!isNotMute" src="@/assets/monitorpublic/spjk_sy1.png" class="iconfont jessibuca-btn" @click="cancelMute()"> -->
        <img src="@/assets/monitorpublic/spjk_sx.png" class="iconfont jessibuca-btn" @click="playBtnClick">
        <img v-if="!fullscreen" src="@/assets/monitorpublic/spjk_qp.png" class="iconfont jessibuca-btn" @click="fullscreenSwich">
        <img v-if="fullscreen" src="@/assets/monitorpublic/spjk_qp2.png" class="iconfont jessibuca-btn" @click="fullscreenSwich">
        <img src="@/assets/newimg/xsjk_ckxq.png" class="iconfont jessibuca-btn" @click="switchImg">
      </div>
    </div>
  </div>
</template>

<script>
let jessibucaPlayer = {};
import axios from 'axios';
export default {
  name: 'jessibuca',
  data() {
    return {
      isButton:true,
      playing: false,
      isNotMute: false,
      fullscreen: false,
      loaded: false, // mute
      speed: 0,
      performance: "", // 工作情况
      kBps: 0,
      btnDom: null,
      videoInfo: null,
      rotate: 0,
      recordType: "webm",
      vod: true, // 点播
      forceNoOffscreen: false,
      showOperateBtns:false
    };
  },
  props: ['videoUrl','_uid','IntelligentlinkageInfo','videoIndex'],
  mounted() {
    
    window.onerror = (msg) => {
    };
    let paramUrl = decodeURIComponent(this.$route.params.url)
    this.$nextTick(() => {
      this.updatePlayerDomSize()
      window.onresize = () => {
        this.updatePlayerDomSize()
      }
      if ( this.videoUrl != null &&  typeof (this.videoUrl) == "undefined") {
        this.videoUrl = paramUrl;
      }
      this.btnDom = document.getElementById("buttonsBox");
      this.play(this.videoUrl)
    })
  },
  watch: {
    videoUrl(newData, oldData) {
      this.play(newData)
    },
    immediate: true
  },
  methods: {
    switchImg(){
      this.$emit('switchImg',this.videoIndex) 
    },
    mouseenter(){
      this.isdisplay = true
    },
    mouseleave(){
      this.isdisplay = false
    },
    updatePlayerDomSize() {
      let dom = this.$refs['container'+this._uid];
      if(dom == undefined){
        return
      }
      let width = dom.parentNode.clientWidth
      let height = (9 / 16) * width
      const clientHeight = Math.min(document.body.clientHeight, document.documentElement.clientHeight)
      if (height > clientHeight) {
        height = clientHeight
        width = (16 / 9) * height
      }

      dom.style.width = width + 'px';
      dom.style.height = height + "px";
    },
    create() {
      let options = {};
      jessibucaPlayer[this._uid] = new window.Jessibuca(Object.assign(
        {
          container: this.$refs['container'+this._uid],
          autoWasm: true,
          background: "",
          controlAutoHide: false,
          debug: false,
          decoder: "./static/js/decoder.js",
          forceNoOffscreen: true,
          hasAudio: typeof (this.hasAudio) == "undefined" ? true : this.hasAudio,
          hasVideo: true,
          heartTimeout: this.isrecord == undefined? 5:1000,
          heartTimeoutReplay: true,
          heartTimeoutReplayTimes: 3,
          hiddenAutoPause: false,
          hotKey: false,
          isFlv: false,
          isFullResize: false,
          isNotMute: this.isNotMute,
          isResize: false,
          keepScreenOn: false,
          loadingText: "请稍等, 视频加载中......",
          loadingTimeout: 10,
          loadingTimeoutReplay: true,
          loadingTimeoutReplayTimes: 3,
          openWebglAlignment: false,
          operateBtns: {
            fullscreen: false,
            screenshot: false,
            play: false,
            audio: false,
            record: false
          },
          recordType: "webm",
          rotate: 0,
          showBandwidth: false,
          supportDblclickFullscreen: false,
          timeout: 10,
          useMSE: true && location.protocol !== "https:",
          useOffscreen: false,
          useWCS: false || location.protocol === "https",
          useWebFullScreen: false,
          videoBuffer: 0,
          wasmDecodeAudioSyncVideo: true,
          wasmDecodeErrorReplay: true,
          wcsUseVideoRender: true
          // videoBuffer: 0, // 缓存时长
          // decoder: "/decoder.js",
          // autoWasm:true,
          // controlAutoHide:false,
          // isResize: false,
          // useWCS: this.useWCS,
          // useMSE: this.useMSE,
          // text: "",
          
          // // background: "bg.jpg",
          // loadingText: "疯狂加载中...",
          // hasAudio:false,
          // debug: false,
          // supportDblclickFullscreen: true,
          // showBandwidth: false, // 显示网速
          // hasVideo:true,
          // operateBtns: {
          //   fullscreen: this.showOperateBtns,
          //   screenshot: this.showOperateBtns,
          //   play: this.showOperateBtns,
          //   audio: this.showOperateBtns,
          // },
          // vod: this.vod,
          // forceNoOffscreen: !this.useOffscreen,
          // isNotMute: this.isNotMute,
          // timeout: 10,
          // loadingTimeout: 10,
          // loadingTimeoutReplay: true,
          // loadingTimeoutReplayTimes: 3,
          // useMSE: location.hostname !== "localhost" && location.protocol !== "https:",
          // useOffscreen: false,
          // useWCS: location.hostname === "localhost" || location.protocol === "https",
          // useWebFullScreen: false,
          // wasmDecodeAudioSyncVideo: true,
          // wasmDecodeErrorReplay: true,
          // wcsUseVideoRender: true,
          // heartTimeout: 5,
          // heartTimeoutReplay: true,
          // heartTimeoutReplayTimes: 3,
          // hiddenAutoPause:false,
          // hotKey:false,
          // isFlv:false,
        },
        options
      ));
      let jessibuca = jessibucaPlayer[this._uid];
      let _this = this;
      jessibuca.on("load", function () {
      });

      jessibuca.on("log", function (msg) {
      });
      jessibuca.on("record", function (msg) {
      });
      jessibuca.on("pause", function () {
        _this.playing = false;
      });
      jessibuca.on("play", function () {
        _this.playing = true;
      });
      jessibuca.on("fullscreen", function (msg) {
        _this.fullscreen = msg
      });

      jessibuca.on("mute", function (msg) {
        _this.isNotMute = !msg;
      });
      jessibuca.on("audioInfo", function (msg) {
      });

      jessibuca.on("bps", function (bps) {
      });
      let _ts = 0;
      jessibuca.on("timeUpdate", function (ts) {
        _ts = ts;
      });

      jessibuca.on("videoInfo", function (info) {
      });

      jessibuca.on("error", function (error) {
      });

      jessibuca.on("timeout", function () {
        if(_this.isrecord != undefined){
         _this.$emit('timeout',_this.videoUrl)
        }
        
      });

      jessibuca.on('start', function () {
      })

      jessibuca.on("performance", function (performance) {
        let show = "卡顿";
        if (performance === 2) {
          show = "非常流畅";
        } else if (performance === 1) {
          show = "流畅";
        }
        _this.performance = show;
      });
      jessibuca.on('buffer', function (buffer) {
      })

      jessibuca.on('stats', function (stats) {
      })

      jessibuca.on('kBps', function (kBps) {
        _this.kBps = Math.round(kBps);
      });

      // 显示时间戳 PTS
      jessibuca.on('videoFrame', function () {

      })

      //
      jessibuca.on('metadata', function () {

      });
    },
    playBtnClick: function (event) {
      this.play(this.videoUrl)
    },
    play: function (url) {
      if (jessibucaPlayer[this._uid]) {
        this.destroy();
      }
      if(url == '' || url == null){
        return
      }
      this.create();
      jessibucaPlayer[this._uid].on("play", () => {
        this.playing = true;
        this.loaded = true;
      });
      if (jessibucaPlayer[this._uid].hasLoaded()) {
        jessibucaPlayer[this._uid].play(url);
      } else {
        jessibucaPlayer[this._uid].on("load", () => {
          jessibucaPlayer[this._uid].play(url);
        });
      }
    },
    pause: function () {
      if (jessibucaPlayer[this._uid]) {
        jessibucaPlayer[this._uid].pause();
      }
      this.playing = false;
      this.err = "";
      this.performance = "";
    },
    screenshot: function () {
      if (jessibucaPlayer[this._uid]) {
        jessibucaPlayer[this._uid].screenshot();
      }
    },
    mute: function () {
      this.isNotMute = false
      if (jessibucaPlayer[this._uid]) {
        jessibucaPlayer[this._uid].mute();
      }
    },
    cancelMute: function () {
      this.isNotMute = true
      if (jessibucaPlayer[this._uid]) {
        jessibucaPlayer[this._uid].cancelMute();
      }
    },
    destroy: function () {
      if (jessibucaPlayer[this._uid]) {
        jessibucaPlayer[this._uid].destroy();
      }
      if (document.getElementById("buttonsBox") == null) {
        this.$refs['container'+this._uid].appendChild(this.btnDom)
      }
      jessibucaPlayer[this._uid] = null;
      this.playing = false;
      this.err = "";
      this.performance = "";

    },
    eventcallbacK: function (type, message) {
    },
    fullscreenSwich: function () {
      let isFull = this.isFullscreen()
      jessibucaPlayer[this._uid].setFullscreen(!isFull)
      this.fullscreen = !isFull;
    },
    isFullscreen: function () {
      return document.fullscreenElement ||
        document.msFullscreenElement ||
        document.mozFullScreenElement ||
        document.webkitFullscreenElement || false;
    },
    closeClick: function (){
      this.$emit("closeVideo",this._uid -1)
    },
    gbPlay: function (){
      this.playing = true
      this.$emit("gbPlay")
    },
    gbPause: function (){
      this.$emit("gbPause")
      this.playing = false;
      this.err = "";
      this.performance = "";
    },
  },
  unmounted() {
    if (jessibucaPlayer[this._uid]) {
      jessibucaPlayer[this._uid].destroy();
    }
    if(this.IntelligentlinkageInfo != undefined &&  this.IntelligentlinkageInfo.channelId!= undefined){
     axios.get(userStore.webApiMonitorUrl + '/api/play/stop/' + this.IntelligentlinkageInfo.deviceId + '/' + this.IntelligentlinkageInfo.channelId, {}).then((res) => { })
   }
    this.playing = false;
    this.loaded = false;
    this.performance = "";
  },

}
</script>

<style scoped lang="scss">
.VideoMode{
  width: 100% !important;
    height: 100% !important;
  .buttons-box {
    width: 100%;
    height: 50px;
    background-color: rgba(43, 51, 63, 0.7);
    position: absolute;
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    left: 0;
    bottom: 0;
    user-select: none;
    z-index: 10;
  }

  .jessibuca-btn {
    width: 20px;
    color: rgb(255, 255, 255);
    line-height: 27px;
    margin: 0px 10px;
    padding: 0px 2px;
    cursor: pointer;
    text-align: center;
    font-size: 0.8rem !important;
  }
  .buttons-box-left{
    display: flex;
    align-items: center;
    font-family: 'Arial Normal', 'Arial';
    font-weight: 400;
    font-style: normal;
    font-size: 14px;
    color: #FFFFFF;
  }
  .buttons-box-right {
    position: absolute;
    right: 0;
    display: flex;
    align-items: center;
    height: 50px;
  }
  .jessibuca-container.jessibuca-controls-show{
    width: 100% !important;
    height: 100% !important;
  }
  .jessibuca-container.jessibuca-controls-show video{
    width: 100% !important;
    height: 100% !important;
  }
  .buttonsrescord-box{
    width: 100%;
    height: 60px;
    background-color: rgba(43, 51, 63, 0.7);
    position: absolute;
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
  align-items: center;
  justify-content: space-between;
    left: 0;
    bottom: 0;
    user-select: none;
    z-index: 10;
    padding-left: 10px;
  }
  .buttondisplay-box{
    width: 100%;
    height: 60px;
    position: absolute;
    left: 0;
    bottom: 0;
    user-select: none;
    z-index: 10;
  }
  .spanstyle1{
    font-family: 'Arial Negreta', 'Arial Normal', 'Arial';
    font-weight: 700;
    font-size: 16px;
    color: #00F9A2;
  }
  .spanstyle2{
    font-family: 'Arial Negreta', 'Arial Normal', 'Arial';
    font-weight: 700;
    font-size: 16px;
    color: #FF3300;
  }

}

</style>
